package jetbrains.mps.baseLanguage.dates.runtime.printer;

/*Generated by MPS */

import java.util.List;
import java.util.LinkedList;
import org.joda.time.DateTime;
import java.util.Locale;
import java.io.IOException;

public class CompositePrinter implements Printer {
  private List<Printer> myPrinters = new LinkedList<Printer>();
  private int myEstimatedPrintLength = -1;

  public CompositePrinter() {
  }

  @Override
  public int estimatePrintedLength() {
    if (myEstimatedPrintLength < 0) {
      myEstimatedPrintLength = 0;
      for (Printer printer : myPrinters) {
        myEstimatedPrintLength += printer.estimatePrintedLength();
      }
    }
    return myEstimatedPrintLength;
  }

  public void add(Printer printer) {
    myEstimatedPrintLength = -1;
    myPrinters.add(printer);
  }

  @Override
  public void printTo(Appendable out, DateTime dateTime, Locale locale) throws IOException {
    for (Printer printer : myPrinters) {
      printer.printTo(out, dateTime, locale);
    }
  }
}
