package jetbrains.mps.baseLanguage.dates.runtime.printer;

/*Generated by MPS */

import org.joda.time.DateTime;
import java.util.Locale;
import java.io.IOException;
import java.util.List;

public abstract class ConditionalPrinter implements Printer {
  private int myEstimatedPrintLength = -1;

  public ConditionalPrinter() {
  }

  @Override
  public int estimatePrintedLength() {
    if (myEstimatedPrintLength < 0) {
      myEstimatedPrintLength = 0;
      for (Printer printer : getAllPrinters()) {
        myEstimatedPrintLength = Math.max(myEstimatedPrintLength, printer.estimatePrintedLength());
      }
      return myEstimatedPrintLength;
    }
    return myEstimatedPrintLength;
  }

  @Override
  public void printTo(Appendable out, DateTime dateTime, Locale locale) throws IOException {
    Printer printer = getAllPrinters().get(getPrinterIndex(dateTime, locale));
    printer.printTo(out, dateTime, locale);
  }

  protected abstract int getPrinterIndex(DateTime dateTime, Locale locale);

  protected abstract List<Printer> getAllPrinters();
}
