package jetbrains.mps.build.generictasks.taskfromjar;

/*Generated by MPS */

import java.util.Map;
import java.util.LinkedHashMap;
import java.io.InputStream;
import java.io.IOException;
import java.io.LineNumberReader;
import java.io.InputStreamReader;

public class NamesMap {
  private final Map<String, String> myMap = new LinkedHashMap<String, String>();

  public NamesMap() {
  }

  public void parsePropertyFile(InputStream stream) throws IOException {
    LineNumberReader lnr = new LineNumberReader(new InputStreamReader(stream));
    while (true) {
      String line = lnr.readLine();
      if (line == null) {
        break;
      }
      this.parseLine(line);
    }
  }

  private void parseLine(String line) throws IOException {
    if (line.matches("(\\s)*") || line.startsWith("#")) {
      return;
    }
    String[] strings = line.split("=");
    if (strings.length != 2) {
      throw new IOException("Malformed file in line: " + line);
    }
    this.myMap.put(strings[1], strings[0]);
  }

  public boolean containsClassName(String name) {
    return this.myMap.containsKey(name);
  }

  public String getNameForClass(Class<?> clazz) {
    if (this.myMap.containsKey(clazz.getName())) {
      return this.myMap.get(clazz.getName());
    }
    String shortName = Scanner.getShortClassName(clazz);
    this.myMap.put(clazz.getName(), shortName);
    return shortName;
  }
}
